package gibson.jpaul;

import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;

import static org.junit.Assert.*;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;
import java.nio.charset.StandardCharsets;

public class CalculatorSystemSteps {

	private String input;
	private String actual;

	@Given("input is")
	public void input_is(String input) {
		this.input = input;
	}

	@When("program runs")
	public void program_runs() throws IOException {

		InputStream inputStream = 
		    new ByteArrayInputStream(input.getBytes(StandardCharsets.UTF_8));

		ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
		PrintStream outputStream = new PrintStream(byteArrayOutputStream);

		PrintStream previousOut = System.out;
		InputStream previousIn = System.in;

		System.setIn(inputStream);
		System.setOut(outputStream);

		TerminalAddition.main(null);

		actual = byteArrayOutputStream.toString();

		inputStream.close();
		outputStream.close();

		System.setOut(previousOut);
		System.setIn(previousIn);
	}

	@Then("output should be")
	public void output_should_be(String expected) {
		assertEquals(expected, actual);
	}

}
